// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Constant power factor control function
 * </pre>
 *
 * Protobuf type {@code commonmodule.PFSPC}
 */
public final class PFSPC extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.PFSPC)
    PFSPCOrBuilder {
private static final long serialVersionUID = 0L;
  // Use PFSPC.newBuilder() to construct.
  private PFSPC(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private PFSPC() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new PFSPC();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_PFSPC_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_PFSPC_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.PFSPC.class, openfmb.commonmodule.PFSPC.Builder.class);
  }

  public static final int CTLVAL_FIELD_NUMBER = 1;
  private boolean ctlVal_ = false;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>bool ctlVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The ctlVal.
   */
  @java.lang.Override
  public boolean getCtlVal() {
    return ctlVal_;
  }

  public static final int PFPARAMETER_FIELD_NUMBER = 2;
  private openfmb.commonmodule.OperationDFPF pFParameter_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the pFParameter field is set.
   */
  @java.lang.Override
  public boolean hasPFParameter() {
    return pFParameter_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The pFParameter.
   */
  @java.lang.Override
  public openfmb.commonmodule.OperationDFPF getPFParameter() {
    return pFParameter_ == null ? openfmb.commonmodule.OperationDFPF.getDefaultInstance() : pFParameter_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.OperationDFPFOrBuilder getPFParameterOrBuilder() {
    return pFParameter_ == null ? openfmb.commonmodule.OperationDFPF.getDefaultInstance() : pFParameter_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (ctlVal_ != false) {
      output.writeBool(1, ctlVal_);
    }
    if (pFParameter_ != null) {
      output.writeMessage(2, getPFParameter());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (ctlVal_ != false) {
      size += com.google.protobuf.CodedOutputStream
        .computeBoolSize(1, ctlVal_);
    }
    if (pFParameter_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getPFParameter());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.PFSPC)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.PFSPC other = (openfmb.commonmodule.PFSPC) obj;

    if (getCtlVal()
        != other.getCtlVal()) return false;
    if (hasPFParameter() != other.hasPFParameter()) return false;
    if (hasPFParameter()) {
      if (!getPFParameter()
          .equals(other.getPFParameter())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + CTLVAL_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashBoolean(
        getCtlVal());
    if (hasPFParameter()) {
      hash = (37 * hash) + PFPARAMETER_FIELD_NUMBER;
      hash = (53 * hash) + getPFParameter().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.PFSPC parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.PFSPC parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.PFSPC parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.PFSPC parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.PFSPC parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.PFSPC parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.PFSPC parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.PFSPC parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.PFSPC parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.PFSPC parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.PFSPC parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.PFSPC parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.PFSPC prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Constant power factor control function
   * </pre>
   *
   * Protobuf type {@code commonmodule.PFSPC}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.PFSPC)
      openfmb.commonmodule.PFSPCOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_PFSPC_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_PFSPC_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.PFSPC.class, openfmb.commonmodule.PFSPC.Builder.class);
    }

    // Construct using openfmb.commonmodule.PFSPC.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      ctlVal_ = false;
      pFParameter_ = null;
      if (pFParameterBuilder_ != null) {
        pFParameterBuilder_.dispose();
        pFParameterBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_PFSPC_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.PFSPC getDefaultInstanceForType() {
      return openfmb.commonmodule.PFSPC.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.PFSPC build() {
      openfmb.commonmodule.PFSPC result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.PFSPC buildPartial() {
      openfmb.commonmodule.PFSPC result = new openfmb.commonmodule.PFSPC(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.PFSPC result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.ctlVal_ = ctlVal_;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.pFParameter_ = pFParameterBuilder_ == null
            ? pFParameter_
            : pFParameterBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.PFSPC) {
        return mergeFrom((openfmb.commonmodule.PFSPC)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.PFSPC other) {
      if (other == openfmb.commonmodule.PFSPC.getDefaultInstance()) return this;
      if (other.getCtlVal() != false) {
        setCtlVal(other.getCtlVal());
      }
      if (other.hasPFParameter()) {
        mergePFParameter(other.getPFParameter());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              ctlVal_ = input.readBool();
              bitField0_ |= 0x00000001;
              break;
            } // case 8
            case 18: {
              input.readMessage(
                  getPFParameterFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private boolean ctlVal_ ;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>bool ctlVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The ctlVal.
     */
    @java.lang.Override
    public boolean getCtlVal() {
      return ctlVal_;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>bool ctlVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The ctlVal to set.
     * @return This builder for chaining.
     */
    public Builder setCtlVal(boolean value) {

      ctlVal_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>bool ctlVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearCtlVal() {
      bitField0_ = (bitField0_ & ~0x00000001);
      ctlVal_ = false;
      onChanged();
      return this;
    }

    private openfmb.commonmodule.OperationDFPF pFParameter_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.OperationDFPF, openfmb.commonmodule.OperationDFPF.Builder, openfmb.commonmodule.OperationDFPFOrBuilder> pFParameterBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the pFParameter field is set.
     */
    public boolean hasPFParameter() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The pFParameter.
     */
    public openfmb.commonmodule.OperationDFPF getPFParameter() {
      if (pFParameterBuilder_ == null) {
        return pFParameter_ == null ? openfmb.commonmodule.OperationDFPF.getDefaultInstance() : pFParameter_;
      } else {
        return pFParameterBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setPFParameter(openfmb.commonmodule.OperationDFPF value) {
      if (pFParameterBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        pFParameter_ = value;
      } else {
        pFParameterBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setPFParameter(
        openfmb.commonmodule.OperationDFPF.Builder builderForValue) {
      if (pFParameterBuilder_ == null) {
        pFParameter_ = builderForValue.build();
      } else {
        pFParameterBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergePFParameter(openfmb.commonmodule.OperationDFPF value) {
      if (pFParameterBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          pFParameter_ != null &&
          pFParameter_ != openfmb.commonmodule.OperationDFPF.getDefaultInstance()) {
          getPFParameterBuilder().mergeFrom(value);
        } else {
          pFParameter_ = value;
        }
      } else {
        pFParameterBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearPFParameter() {
      bitField0_ = (bitField0_ & ~0x00000002);
      pFParameter_ = null;
      if (pFParameterBuilder_ != null) {
        pFParameterBuilder_.dispose();
        pFParameterBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.OperationDFPF.Builder getPFParameterBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getPFParameterFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.OperationDFPFOrBuilder getPFParameterOrBuilder() {
      if (pFParameterBuilder_ != null) {
        return pFParameterBuilder_.getMessageOrBuilder();
      } else {
        return pFParameter_ == null ?
            openfmb.commonmodule.OperationDFPF.getDefaultInstance() : pFParameter_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDFPF pFParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.OperationDFPF, openfmb.commonmodule.OperationDFPF.Builder, openfmb.commonmodule.OperationDFPFOrBuilder> 
        getPFParameterFieldBuilder() {
      if (pFParameterBuilder_ == null) {
        pFParameterBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.OperationDFPF, openfmb.commonmodule.OperationDFPF.Builder, openfmb.commonmodule.OperationDFPFOrBuilder>(
                getPFParameter(),
                getParentForChildren(),
                isClean());
        pFParameter_ = null;
      }
      return pFParameterBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.PFSPC)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.PFSPC)
  private static final openfmb.commonmodule.PFSPC DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.PFSPC();
  }

  public static openfmb.commonmodule.PFSPC getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<PFSPC>
      PARSER = new com.google.protobuf.AbstractParser<PFSPC>() {
    @java.lang.Override
    public PFSPC parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<PFSPC> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<PFSPC> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.PFSPC getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

